/*
ID: espr1t
TASK: Monopoly
KEYWORDS: Medium, Divide & Conquer
*/

#include <cstdio>
#include <vector>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 500005;

int n, m;
int a[MAX];

void update(int idx1, int idx2, int& best, int& start) {
    if (best < idx2 - idx1 + 1 || (best == idx2 - idx1 + 1 && idx1 < start))
        best = idx2 - idx1 + 1, start = idx1;
}

void eval(int idx, int size, int& best, int& start) {
    vector < pair <long long, int> > left, right;
    long long sumL = 0;
    for (int i = idx; i >= max(0, idx - size); i--) {
        sumL += a[i];
        while (!left.empty() && left.back().first >= sumL)
            left.pop_back();
        left.push_back(make_pair(sumL, i));
    }
    long long sumR = 0;
    right.push_back(make_pair(sumR, idx));
    for (int i = idx + 1; i < min(n, idx + size + 1); i++) {
        sumR += a[i];
        while (!right.empty() && right.back().first >= sumR)
            right.pop_back();
        right.push_back(make_pair(sumR, i));
    }
    
    int idxL = (int)left.size() - 1, idxR = 0;
    while (idxL >= 0 && idxR < (int)right.size()) {
        if (left[idxL].first + right[idxR].first <= m) {
            update(left[idxL].second, right[idxR].second, best, start);
            idxR++;
        } else idxL--;
    }
}

void solve() {
    int best = 0, start = -1;
    
    int size = n;
    while (best < size) {
        for (int idx = 0; idx < n; idx += size / 2)
            eval(idx, size, best, start);
        size /= 2;
    }
    
    fprintf(out, "%d %d\n", best, start + 1);
}

int main(void) {
    //in = fopen("Monopoly.in", "rt");
    
    fscanf(in, "%d %d", &n, &m);
    for (int i = 0; i < n; i++)
        fscanf(in, "%d", &a[i]);
    solve();
    
    return 0;
}
